import Blender
from Blender.BGL import *
import GUI

# ***********Blender 2.14 GUI WIZARD Script ********************
# *********No More fiddling around with positioning numbers,****
# ***************"Dialog Editor" for Blender ! *****************
# --------------------------------------------------------------
# Copyright July 18, 2001 Bradley Berthold *nikolatesla20*
# --------------------------------------------------------------
# Please, feel free to examine the code and learn :), but please
# do not copy it directly - I worked hard on this! :)
# ENJOY and I hope some of you find this useful!
#
# I choose to make mostly classes because it makes it easier to
# get the data, without having a bunch of stupid "global" statements
# The base class is CButton, all other classes derive from it.
# *************************************************************
fs = GUI.FileSelector()


class CButton:
	
	def __init__(self):
		self.Type = 'Button'
		self.Move = 1
		self.Command = 'pass'
		self.Size = 0

	def SetParams(self,Name,Event,X,Y,Width,Height,Selected):
		self.X = X
		self.Y = Y
		self.Width = Width
		self.Height = Height
		self.Name = Name
		self.Selected = Selected
		self.EventNum = Event
		self.ID = Name
		self.Integer = 0
		self.SetCommand()
		
	def SetCommand(self):
		self.Command = 'Blender.Draw.Button('+'"'+str(self.Name)+'"'+',' + str(self.EventNum)+','+str(self.X)+','+str(self.Y)+','+str(self.Width)+','+str(self.Height)+')'

	def SaveMe(self,FileObj):
		TempStr ='	Blender.Draw.Button('+'"'+str(self.Name)+'"'+','+str(self.EventNum)+','+str(self.X)+','+str(self.Y)+','+str(self.Width)+','+str(self.Height)+')\n'
		FileObj.write(TempStr)
		
	def Draw(self):
		exec(self.Command)

class CToggle(CButton):
	def SetParams(self,Name,Event,X,Y,Width,Height,Selected,Initial):
		self.Initial = Initial
		self.Type = 'Toggle'
		CButton.SetParams(self,Name,Event,X,Y,Width,Height,Selected)
	
	def SaveMe(self,FileObj):
		TempStr ='	'+self.ID + ' = '+'Blender.Draw.Toggle('+'"'+str(self.Name)+'"'+','+str(self.EventNum)+','+str(self.X)+','+str(self.Y)+','+str(self.Width)+','+str(self.Height)+','+self.ID+'.val'+')\n'
		FileObj.write(TempStr)
		
	def SetCommand(self):
		self.Command = 'Blender.Draw.Toggle('+'"'+str(self.Name)+'"'+',' + str(self.EventNum)+','+str(self.X)+','+str(self.Y)+','+str(self.Width)+','+str(self.Height)+','+str(self.Initial)+')'


class CSlider(CButton):
	
	def SetParams(self,Name,Event,X,Y,Width,Height,Selected,Initial,Min,Max):
		self.Initial = Initial
		self.Min = Min
		self.Max = Max
		self.Type = 'Slider'
		self.Update = 0
		CButton.SetParams(self,Name,Event,X,Y,Width,Height,Selected)

	def SaveMe(self,FileObj):
		TempStr ='	'+self.ID+' = '+'Blender.Draw.Slider('+'"'+str(self.Name)+'"'+','+str(self.EventNum)+','+str(self.X)+','+str(self.Y)+','+str(self.Width)+','+str(self.Height)+','+self.ID+'.val'+','+str(self.Min)+','+str(self.Max)+','+str(self.Update)+')\n'
		FileObj.write(TempStr)

	def SetCommand(self):
		if self.Integer == 0:
			self.Initial = float(self.Initial)
		if self.Integer == 1:
			self.Initial = int(self.Initial)
		self.Command = 'Blender.Draw.Slider('+'"'+str(self.Name)+'"'+','+str(self.EventNum)+','+str(self.X)+','+str(self.Y)+','+str(self.Width)+','+str(self.Height)+','+str(self.Initial)+','+str(self.Min)+','+str(self.Max)+','+str(self.Update)+')'

class CNumber(CButton):
	def SetParams(self,Name,Event,X,Y,Width,Height,Selected,Initial,Min,Max):
		self.Initial = Initial
		self.Min = Min
		self.Max = Max
		self.Type = 'Number'
		CButton.SetParams(self,Name,Event,X,Y,Width,Height,Selected)

	def SaveMe(self,FileObj):
		TempStr ='	'+self.ID+' = '+'Blender.Draw.Number('+'"'+str(self.Name)+'"'+','+str(self.EventNum)+','+str(self.X)+','+str(self.Y)+','+str(self.Width)+','+str(self.Height)+','+self.ID+'.val'+','+str(self.Min)+','+str(self.Max)+')\n'
		FileObj.write(TempStr)


	def SetCommand(self):
		if self.Integer == 0:
			self.Initial = float(self.Initial)
		if self.Integer == 1:
			self.Initial = int(self.Initial)
		self.Command = 'Blender.Draw.Number('+'"'+str(self.Name)+'"'+','+str(self.EventNum)+','+str(self.X)+','+str(self.Y)+','+str(self.Width)+','+str(self.Height)+','+str(self.Initial)+','+str(self.Min)+','+str(self.Max)+')'	
		
class CString(CButton):

	def SetParams(self,Name,Event,X,Y,Width,Height,Selected,Initial):
		self.Initial = Initial
		CButton.SetParams(self,Name,Event,X,Y,Width,Height,Selected)
		self.Type = 'String'
		
	def SaveMe(self,FileObj):
		TempStr ='	'+self.ID+' = '+'Blender.Draw.String('+'"'+str(self.Name)+'"'+','+str(self.EventNum)+','+str(self.X)+','+str(self.Y)+','+str(self.Width)+','+str(self.Height)+','+self.ID+'.val'+',255)\n'
		FileObj.write(TempStr)


	def SetCommand(self):
		self.Command = 'Blender.Draw.String('+'"'+str(self.Name)+'"'+','+str(self.EventNum)+','+str(self.X)+','+str(self.Y)+','+str(self.Width)+','+str(self.Height)+','+'"'+str(self.Initial)+'"'+',255)'

class CSelectBox:

	def SetBox(self,X,Y,Width,Height):
		self.X = X
		self.Y = Y
		self.Width = Width
		self.Height = Height

	def SetBoxToButton(self,ButtonObj):
		self.X = ButtonObj.X-8
		self.Y = ButtonObj.Y -8
		self.Width = ButtonObj.Width + 16
		self.Height = ButtonObj.Height + 16

	def DrawBox(self):
		glColor3f(.6,.1,.1)
		glBegin(GL_QUADS)
		glVertex2d(self.X,self.Y)
		glVertex2d(self.X,self.Y + self.Height)
		glVertex2d(self.X+self.Width,self.Y+self.Height)
		glVertex2d(self.X+self.Width,self.Y)
		glEnd()

# This was originally part of the CGUI object, but I needed to seperate it
# because the save GUI does not like it that way....:(
def SaveBasic(self):
		# function to save data to a basic python script
		# no objects, simple global variables. Boring, in other words..
		global fs
		filename = fs.filename
		File = open(filename,'wb')
		File.write('import Blender\nfrom Blender.BGL import * \n \n \n')
		# write out all the "global" button variables
		# Note that we do not need a variable for just a button.
		File.write('# These are your button object global variables! \n \n')
		for x in self.ButtonList.keys():
			TempButton = self.ButtonList[x]
			if (TempButton.Type == 'String') and (TempButton.Initial == ''):
				TempButton.Initial = '""'
			if (TempButton.Type <> 'Button'):
				ButtonStr = TempButton.ID + ' = Blender.Draw.Create(' + str(TempButton.Initial) + ')\n'
				File.write(ButtonStr)
		File.write('\n#Here is the main Draw() routine. All your drawing \n#Should be done in this function.\n')
		File.write('def Draw(): \n')
		# I need to put the global statements in here so variables can be accessed!
		File.write('	# You must use the global keyword here to allow you to modify\n')
		File.write('	# a variable outside the scope of the function.\n')
		for x in self.ButtonList.keys():
			TempButton = self.ButtonList[x]
			ButtonStr = '	global '+TempButton.ID + '\n'
			File.write(ButtonStr)
		File.write('	# Change this color according to what you like ;) \n')
		File.write('	glClearColor(.2,.2,.2,0.0)\n')
		File.write('	glClear(GL_COLOR_BUFFER_BIT) \n')
		# Each button knows how to save itself, tell them to do it, and pass them
		# a file object to do it with.
		for x in self.ButtonList.keys():
			TempButton = self.ButtonList[x]
			TempButton.SaveMe(File)
		File.write ('\n \n \n')
		File.write ('# Here is the main Window Event function. \n#Right now it only has a exit key defined.\n')
		File.write ('def Events(eventnum,eventmod): \n')
		File.write ('	if eventnum==Blender.Draw.XKEY: \n')
		File.write ('		Blender.Draw.Exit() \n')
		File.write('\n \n \n')
		File.write('# These are the button Events handlers.\n')
		File.write('def ButEvent(butnum): \n')
		for x in self.ButtonList.keys():
			TempButton = self.ButtonList[x]
			ButtonStr = '	'+'if butnum=='+str(TempButton.EventNum)+': \n'
			ButtonStr2 = '		'+'# EVENT HANDLER FOR '+TempButton.ID+'\n'
			ButtonStr3 = '		'+'# Put your code in here to respond to the event \n'
			ButtonStr4 = '		'+'pass \n'
			File.write(ButtonStr)
			File.write(ButtonStr2)
			File.write(ButtonStr3)
			File.write(ButtonStr4)
			File.write('\n \n')
		File.write('\n \n \n')
		File.write('# The Main Blender.Draw.Register() Call...\n')
		File.write('Blender.Draw.Register(Draw,Events,ButEvent)\n')
		File.close()
		


class CGUI:
	
	# // Member functions below....
	
	def DrawButtonOptions(self):
		# this routine draws extra buttons to support special options that a
		# button object might have, for example, sliders have a min/max/initial setting.
		if self.SelectedItem <> '':
			TempButton = self.ButtonList[self.SelectedItem]
			self.FloatOrInt.val = TempButton.Integer
			if TempButton.Type == 'Toggle':
				self.ToggleOption.val = self.ButtonList[self.SelectedItem].Initial
				self.ToggleOption = Blender.Draw.Toggle("Init.State",16000,260,0,60,25,self.ToggleOption.val)
			if (TempButton.Type == 'Slider') or (TempButton.Type=='Number'):
				self.FloatOrInt = Blender.Draw.Toggle("Int",25000,450,0,60,25,self.FloatOrInt.val)
				if TempButton.Type == 'Slider':
					self.UpdateButton.val = TempButton.Update
					self.UpdateButton = Blender.Draw.Toggle("Update",27000,510,0,60,25,self.UpdateButton.val)
				self.SlideInit.val = TempButton.Initial
				self.SlideMin.val = TempButton.Min
				self.SlideMax.val = TempButton.Max
				if self.FloatOrInt.val == 0:
					self.SlideMin = Blender.Draw.Number("Min: ",17000,260,0,60,25,float(self.SlideMin.val),0,32000)
					self.SlideMax = Blender.Draw.Number("Max: ",18000,320,0,60,25,float(self.SlideMax.val),0,32000)
					self.SlideInit = Blender.Draw.Number("Init: ",19000,380,0,70,25,float(self.SlideInit.val),0,32000)
				if self.FloatOrInt.val == 1:
					self.SlideMin = Blender.Draw.Number("Min: ",17000,260,0,60,25,int(self.SlideMin.val),0,32000)
					self.SlideMax = Blender.Draw.Number("Max: ",18000,320,0,60,25,int(self.SlideMax.val),0,32000)
					self.SlideInit = Blender.Draw.Number("Init: ",19000,380,0,70,25,int(self.SlideInit.val),0,32000)
					
	def Draw(self):
		# We are going to draw some decorations...
		glGetFloatv(GL_SCISSOR_BOX,self.WinSize)
		glClearColor(.1,.3,.3,0.0)
		glClear(GL_COLOR_BUFFER_BIT)
		glColor3f(.1,.4,.4)
		glBegin(GL_QUADS)
		glVertex2d(0,0)
		glVertex2d(0,30)
		glVertex2d(self.WinSize[2],30)
		glVertex2d(self.WinSize[2],0)
		glEnd()
		glBegin(GL_QUADS)
		glVertex2d(0,self.WinSize[3])
		glVertex2d(self.WinSize[2],self.WinSize[3])
		glVertex2d(self.WinSize[2],self.WinSize[3] - 25)
		glVertex2d(0,self.WinSize[3]-25)
		glEnd()
		glColor3f(.8,.8,.1)
		glRasterPos2f(0.0,self.WinSize[3]-20)
		Blender.Draw.Text("A-Button i-Slider T-Toggle J-String N-Number G-Move S-Size D-Delete X-Exit B-Save")
		if self.SelectedItem == '':
			self.RenameString = Blender.Draw.String("Label: ",14000,40,0,110,25,self.RenameString.val,20)
			self.RenameCodeString = Blender.Draw.String("ID: ",20000,150,0,110,25,self.RenameCodeString.val,20)
		if self.SelectedItem <> '':
			self.RenameString = Blender.Draw.String("Label: ",14000,40,0,110,25,self.ButtonList[self.SelectedItem].Name,20)
			self.RenameCodeString = Blender.Draw.String("ID: ",20000,150,0,110,25,self.ButtonList[self.SelectedItem].ID,20)
		self.DrawButtonOptions()
		self.SelectBox.DrawBox()
		# Guess what this does! :) It scans through the memory list of button objects
		# and calls each one's draw function. Each object knows how to draw itself.
		# Object Oriented Programming rocks!
		if len(self.ButtonList) > 0:
				for item in self.ButtonList.keys():
					self.ButtonList[item].Draw()
					
	def Events(self,eventnum,eventmod):
		if eventnum == Blender.Draw.XKEY:
			del self.ButtonList
			del self.EventList
			del self.WinSize
			del self.SelectBox
			del self.ToggleOption
			del self.RenameString
			del self.RenameCodeString
			del self.AddMenu
			
			Blender.Draw.Exit()
		if eventnum == Blender.Draw.LEFTMOUSE:
			if eventmod == 1:
				if self.SelectedItem <> '':
					self.ButtonList[self.SelectedItem].Move = 0
					self.ButtonList[self.SelectedItem].Size = 0
				self.SelectedItem = ''
				self.SelectBox.SetBox(0,0,1,1)
				Blender.Draw.Draw()
		if eventnum == Blender.Draw.MOUSEX:
			self.CalcXMousePos(eventmod)
			if self.SelectedItem <> '':
				if self.ButtonList[self.SelectedItem].Move == 1:
					self.ButtonList[self.SelectedItem].X = self.MouseX
					self.ButtonList[self.SelectedItem].SetCommand()
					TempButton = self.ButtonList[self.SelectedItem]	
					self.SelectBox.SetBoxToButton(TempButton)
					Blender.Draw.Draw()
				if self.ButtonList[self.SelectedItem].Size == 1:
					self.ButtonList[self.SelectedItem].Width = self.MouseX - self.ButtonList[self.SelectedItem].X
					if self.ButtonList[self.SelectedItem].Width < 15:
						self.ButtonList[self.SelectedItem].Width = 15
					self.ButtonList[self.SelectedItem].SetCommand()
					TempButton = self.ButtonList[self.SelectedItem]
					self.SelectBox.SetBoxToButton(TempButton)
					Blender.Draw.Draw()

		if eventnum == Blender.Draw.MOUSEY:
			self.CalcYMousePos(eventmod)
			if self.SelectedItem <> '':
				if self.ButtonList[self.SelectedItem].Move == 1:
					self.ButtonList[self.SelectedItem].Y = self.MouseY
					self.ButtonList[self.SelectedItem].SetCommand()
					TempButton = self.ButtonList[self.SelectedItem]
					self.SelectBox.SetBoxToButton(TempButton)
					Blender.Draw.Draw()
				if self.ButtonList[self.SelectedItem].Size == 1:
					self.ButtonList[self.SelectedItem].Height = self.MouseY - self.ButtonList[self.SelectedItem].Y
					if self.ButtonList[self.SelectedItem].Height < 8:
						self.ButtonList[self.SelectedItem].Height = 8
					self.ButtonList[self.SelectedItem].SetCommand()
					TempButton = self.ButtonList[self.SelectedItem]
					self.SelectBox.SetBoxToButton(TempButton)
					Blender.Draw.Draw()

		if (eventnum==Blender.Draw.AKEY) and (eventmod==1):		
			self.AddButton('Button')

		if (eventnum==Blender.Draw.IKEY) and (eventmod==1):
			self.AddButton('Slider')
			
		if (eventnum==Blender.Draw.TKEY) and (eventmod==1):
			self.AddButton('Toggle')

		if (eventnum==Blender.Draw.JKEY) and (eventmod==1):
			self.AddButton('String')
			
		if (eventnum==Blender.Draw.NKEY) and (eventmod==1):
			self.AddButton('Number')

		if (eventnum==Blender.Draw.BKEY) and (eventmod==1):
			self.DoBasicSave()
			
		if eventnum == Blender.Draw.GKEY:
			if eventmod == 1:
				if self.SelectedItem <> '':
					self.ButtonList[self.SelectedItem].Move = 1
									
		if eventnum == Blender.Draw.SKEY:
			if eventmod == 1:
				if self.SelectedItem <> '':
					self.ButtonList[self.SelectedItem].Size = 1

		if eventnum == Blender.Draw.DKEY:
			if eventmod == 1:
				if self.SelectedItem <> '':
					del self.ButtonList[self.SelectedItem]
					del self.EventList[self.SelectedItem]
					self.SelectedItem = ''
					self.SelectBox.SetBox(0,0,1,1)
				Blender.Draw.Draw()
		


	def ButEvents(self,butnum):
		
		if butnum == 14000: # rename LABEL function
			if self.SelectedItem <> '':
				self.ButtonList[self.SelectedItem].Name = self.RenameString.val
				self.ButtonList[self.SelectedItem].SetCommand()
				Blender.Draw.Redraw()

		if butnum == 20000: # Rename Control ID function
			if self.SelectedItem <> '':
				self.ButtonList[self.SelectedItem].ID = self.RenameCodeString.val
				self.ButtonList[self.SelectedItem].SetCommand()
				Blender.Draw.Redraw()
				
		if butnum == 25000: # Float or Int Toggle
			if self.SelectedItem <> '':
				self.ButtonList[self.SelectedItem].Integer = self.FloatOrInt.val
				self.ButtonList[self.SelectedItem].SetCommand()
			Blender.Draw.Redraw()
			pass
		
		if butnum == 16000: # Toggle Options
			# this button is not visible unless something is selected,
			# so it should be safe to go ahead no matter what.
			self.ButtonList[self.SelectedItem].Initial = self.ToggleOption.val
			self.ButtonList[self.SelectedItem].SetCommand()
			Blender.Draw.Redraw()

		if (butnum == 17000) or (butnum == 18000) or (butnum == 19000): #  Min/Max adjusts
			self.ButtonList[self.SelectedItem].Min = self.SlideMin.val
			self.ButtonList[self.SelectedItem].Max = self.SlideMax.val
			self.ButtonList[self.SelectedItem].Initial = self.SlideInit.val
			self.ButtonList[self.SelectedItem].SetCommand()
			Blender.Draw.Redraw()
		
		if butnum == 27000: # Update button option for sliders
			self.ButtonList[self.SelectedItem].Update = self.UpdateButton.val
			self.ButtonList[self.SelectedItem].SetCommand()
			Blender.Draw.Redraw()
			
		# This code scans through the "linked list" dictionary of button objects,
		# and checks their event codes..
		if len(self.EventList) > 0:
			for item in self.EventList.keys():
				if self.EventList[item] == butnum:
					TempButton = self.ButtonList[item]
					self.SelectBox.SetBoxToButton(TempButton)
					self.SelectedItem = item
					self.ButtonList[self.SelectedItem].Move = 0
					self.ButtonList[self.SelectedItem].Size = 0
					Blender.Draw.Draw()

	
	def AddButton(self,Type):
		self.ButtonPosY = self.ButtonPosY + 30
		if self.ButtonPosY > self.WinSize[3]:
			self.ButtonPosY = 60
		if Type == 'Button':
			self.ButtonCount = self.ButtonCount + 1
			self.ButtonName = 'Button' + str(self.ButtonCount)
		if Type == 'Toggle':
			self.ToggleCount = self.ToggleCount + 1
			self.ButtonName = 'Toggle' + str(self.ToggleCount)
		if Type == 'Slider':
			self.SliderCount = self.SliderCount + 1
			self.ButtonName = 'Slider' + str(self.SliderCount)
		if Type =='String':
			self.StringCount = self.StringCount + 1
			self.ButtonName = 'String' + str(self.StringCount)
		if Type =='Number':
			self.NumberCount = self.NumberCount + 1
			self.ButtonName = 'Number' + str(self.NumberCount)
		self.ButtonEvent = self.ButtonEvent +1
		if Type == 'Button':
			TempButton = CButton()
		if Type == 'Toggle':
			TempButton = CToggle()
		if Type == 'Slider':
			TempButton = CSlider()
		if Type == 'String':
			TempButton = CString()
		if Type == 'Number':
			TempButton = CNumber()
		if (Type=='Button'):
			TempButton.SetParams(self.ButtonName,self.ButtonEvent,100,30,70,30,0)
		if (Type=='Toggle'):
			TempButton.SetParams(self.ButtonName,self.ButtonEvent,100,30,70,30,0,0)
		if (Type == 'Slider'):
			TempButton.SetParams(self.ButtonName,self.ButtonEvent,100,30,120,30,0,50,0,100)
		if (Type == 'String'):
			TempButton.SetParams(self.ButtonName,self.ButtonEvent,100,30,70,30,0,'')
		if (Type == 'Number'):
			TempButton.SetParams(self.ButtonName,self.ButtonEvent,100,30,70,30,0,0,0,100)
		self.ButtonList[self.ButtonName] = TempButton
		self.EventList[self.ButtonName] = self.ButtonEvent
		self.SelectedItem = self.ButtonName
		Blender.Draw.Draw()

	def CalcXMousePos(self,XVal):
		self.MouseX = -((self.WinSize[0] + self.WinSize[2]) - XVal) + self.WinSize[2]

	def CalcYMousePos(self,YVal):
		self.MouseY = -((self.WinSize[1] + self.WinSize[3]) - YVal) + self.WinSize[3]

	
	def DoBasicSave(self):
		global fs
		fs.activate(SaveBasic,self)
		Blender.Draw.Redraw()
				
	def __init__(self):
		self.ButtonList = {}
		self.EventList = {}
		self.SelectBox = CSelectBox()
		self.SelectBox.SetBox(0,0,1,1)
		self.SelectedItem = ''
		self.WinSize = Buffer(GL_FLOAT,4)
		self.ButtonPosY = 30
		self.ButtonEvent = 0
		self.ButtonName = 'Button'
		self.ButtonCount = 0
		self.SliderCount = 0
		self.StringCount = 0
		self.ToggleCount = 0
		self.NumberCount = 0
		self.ToggleOption = Blender.Draw.Create(0)
		self.SlideInit = Blender.Draw.Create(0.0)
		self.SlideMin = Blender.Draw.Create(0.0)
		self.SlideMax = Blender.Draw.Create(0.0)
		self.RenameString = Blender.Draw.Create("")
		self.RenameCodeString = Blender.Draw.Create("")
		self.AddMenu = Blender.Draw.Create(0)
		self.FloatOrInt = Blender.Draw.Create(0)
		self.UpdateButton = Blender.Draw.Create(0)
		Blender.Draw.Register(self.Draw,self.Events,self.ButEvents)


# creating this object also starts
# the wizard gui ! :)
mygui = CGUI()


